various updates
[distro-setup] / mount-latest-remote
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7
8 # http://www.apache.org/licenses/LICENSE-2.0
9
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 source /usr/local/lib/err
17
18 script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
19
20 if (( ! $# )); then
21 echo "mount-latest-remote: error: expected 1 or more host arguments"
22 exit 1
23 fi
24
25 $script_dir/install-my-scripts
26 cd /usr/local
27
28 ecode=0
29 failed_hosts=()
30
31 # exit code run
32 er() {
33 local ret=0
34 "$@" || ret=$?
35 if (( ret )); then
36 echo "$0: failed command: $*"
37 failed_hosts+=($tg)
38 fi
39 if (( ret > ecode )); then
40 ecode=$ret
41 fi
42 }
43 for tg; do
44 rsynctg=$tg
45 if [[ $tg == *:* ]]; then
46 rsynctg="[$tg]"
47 fi
48 # R = relative, t = times, O = omit-dir-times, p = perms
49 er rsync -RtOp bin/{mount-latest-subvol,check-subvol-stale} lib/err "root@$rsynctg:/usr/local" || continue
50 # this can hang if we have an old nfs mount
51 ssh root@$tg timeout -s 9 600 /usr/local/bin/mount-latest-subvol ||:
52 done
53
54 if (( $# == ${#failed_hosts[@]} )); then
55 echo "$0: error: all hosts failed: $*" >&2
56 elif (( ${#failed_hosts[@]} )); then
57 echo "$0: error: some hosts failed: ${failed_hosts[@]}" >&2
58 fi
59 exit $ecode